/* 菊地文雄, 山本昌宏「微分方程式と計算機演習」, 山海堂 (1991)
   P. 13 のプログラムをC言語に書き直した。
  ** GAUSS ELIMINATION METHOD **
  n : NUMBER OF UNKNOWS
  a : COEFFICIENT MATRIX
  f : KNOWN VECTOR & SOLUTION VECTORS
*/

#include <stdio.h>
#include <stdlib.h> // exit()
#define NDIM (100)

void gauss(int ndim, double a[ndim][ndim], double f[], int N);

int main(void)
{
  int n, i, j;
  double a[NDIM][NDIM], f[NDIM];
  printf("INPUT : N=\n"); // 最後の \n は不要かも
  scanf("%d", &n);
  if (n<=1)
    exit(0);
  for (i = 0; i < n; i++)
    for (j = 0; j < n; j++) {
      printf("INPUT : A(%3d,%3d)=\n", i+1, j+1); // 最後の \n は不要かも
      scanf("%lf", &a[i][j]);
    }
  for (i = 0; i < n; i++) {
    printf(" INPUT : F(%3d)=\n", i+1); // 最後の \n は不要かも
    scanf("%lf", &f[i]);
  }
  gauss(NDIM,a,f,n);
  for (i = 0; i < 5; i++)
    printf("  I     X(I)    ");
  printf("\n");
  for (i = 0; i < n; i++) {
    printf("%3d%12.4e ",i+1, f[i]); //I3 は %3d, PE12.4 は %12.4e (1Pは無視)
    if ((i+1) % 5 == 0 || i+1 == n)
      printf("\n");
  }
}

void gauss(int ndim, double a[ndim][ndim], double f[], int n)
{
  int i, j, k;
  double aa;
  // FORWARD ELIMITNATION
  for (i=0; i<n-1; i++)
    for (j=i+1; j<n; j++) {
      aa = a[j][i] / a[i][i];
      for (k=i+1; k<n; k++)
    a[j][k] -= aa * a[i][k];
      f[j] -= aa * f[i];
    }
  // BACKWARD SUBSTITUTION
  f[n-1] /= a[n-1][n-1];
  for (i=n-2;i>=0;i--) {
    for (j=i+1; j<n; j++)
      f[i] -= a[i][j] * f[j];
    f[i] /= a[i][i];
  }
}
