// 菊地文雄, 山本昌宏「微分方程式と計算機演習」, 山海堂 (1991), P. 20
/* ** GAUSS ELIMINATION METHOD **
   **  FOR TRIDIAGONAL SYSTEM  **
   N : NUMBER OF UNKNOWS
   A : LOWER DIAGONAL
   B : DIAGONAL
   C : UPPER DIAGONAL
   F : KNOWN VECTOR & SOLUTION VECTOR
*/

#include <stdio.h>
#include <stdlib.h>
#define NDIM (100)

void trid(double a[], double b[], double c[], double f[], int n);

int main(void)
{
  int n, i;
  double a[NDIM], b[NDIM], c[NDIM], f[NDIM];
  printf("INPUT : N=\n");
  scanf("%d", &n);
  if (n <= 1)
    exit(1);
  printf("INPUT : B(I),C(I) FOR I=1\n");
  scanf("%lf%lf", &b[0], &c[0]);
  for (i = 1; i < n-1; i++) {
    printf("INPUT : A(I),B(I),C(I) FOR I=%3d\n", i+1);
    scanf("%lf%lf%lf", &a[i],&b[i],&c[i]);
  }
  printf("INPUT : A(I),B(I) FOR I=N\n");
  scanf("%lf%lf", &a[n-1], &b[n-1]);
  for (i=0; i < n; i++) {
    printf("INPUT : F(%3d)=\n", i+1);
    scanf("%lf", &f[i]);
  }
  trid(a,b,c,f,n);
  for (i = 0; i < 5; i++)
    printf("  I     X(I)    ");
  printf("\n");
  for (i=0; i<n; i++) {
    printf("%3d%12.4e ", i+1, f[i]);
    if ((i+1) % 5 == 0 || i+1 == n)
      printf("\n");
  }
}

void trid(double a[], double b[], double c[], double f[], int n)
{
  int i;
  double aa;
  // FORWARD ELIMITNATION
  for (i=0; i<n-1; i++) {
    aa = a[i+1] / b[i];
    b[i+1] -= aa * c[i];
    f[i+1] -= aa * f[i];
  }
  // BACKWARD SUBSTITUTION
  f[n-1] /= b[n-1];
  for (i=n-2; i>=0; i--)
    f[i] = (f[i] - c[i] * f[i+1]) / b[i];
}
