// C  菊地文雄, 山本昌宏「微分方程式と計算機演習」, 山海堂 (1991), p. 146
/* ** EULER,HEUN,AND RUNGE-KUTTA METHODS **
   ** FOR ORDINARY DIFFERENTIAL EQUATIONS **
   NFUNC : FUNCTION NUMBER
   METHOD : METHOD NUMBER
   T : TIME VARIABLE
   X : APPROXIMATE VALUE OF SOLUTION
   (T0,X0) : INITIAL VALUE OF (T,X)
   H : TIME INCREMENT
   TMAX : UPPER LIMIT OF TIME
*/

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

double f(double t, double x, int nfunc);

int main(void)
{
  int nfunc, method, nstep;
  double t0, x0, h, Tmax, t, x, fk1, fk2, fk3, fk4;
  printf("INPUT : NFUNC=\n");
  scanf("%d", &nfunc);
  printf("EULER : METHOD=1\n");
  printf("HEUN  :       =2\n");
  printf("RUNGE-KUTTA   =3\n");
  printf("INPUT : METHOD=");
  scanf("%d", &method);
  printf("INPUT : T0=\n");
  scanf("%lf", &t0);
  printf("INPUT : x0=\n");
  scanf("%lf", &x0);
  printf("INPUT : h=\n");
  scanf("%lf", &h);
  printf("INPUT : Tmax=\n");
  scanf("%lf", &Tmax);
  t=t0;
  x=x0;
  nstep=0;
  do {
    if (method == 1) {
      x += h*f(t,x,nfunc);
    }
    else if (method == 2) {
      fk1=f(t,x,nfunc);
      fk2=f(t+h,x+h*fk1,nfunc);
      x += h*(fk1+fk2)/2.0;
    }
    else {
      fk1=f(t,x,nfunc);
      fk2=f(t+h/2.0,x+h*fk1/2.0,nfunc);
      fk3=f(t+h/2.0,x+h*fk2/2.0,nfunc);
      fk4=f(t+h,x+h*fk3,nfunc);
      x += h*(fk1+2.0*fk2+2.0*fk3+fk4)/6.0;
    }
    nstep++;
    t=t0+h*nstep;
    printf("T=%12.4e X=%12.4e\n", t, x);
  }
  while ((h > 0.0 && t+h < Tmax+0.1*h) || (h < 0.0 && t+h > Tmax+0.1*h));
  return 0;
}

double f(double t, double x, int nfunc)
{
  if (nfunc == 1) return x;
  if (nfunc == 2) return 1.0 - x * x;
  if (nfunc == 3) return x * x;
  return 0.0;
}
