// 菊地文雄, 山本昌宏「微分方程式と計算機演習」, 山海堂 (1991), p. 164
/* **  EULER, HEUN, AND RUNGE-KUTTA  **
   ** METHODS FOR SYSTEM OF ORDINARY **
   **    DIFFERENTIAL EQUATIONS-1    **
   NFUNC : FUNCTION NUMBER
   METHOD : METHOD NUMBER
   N : NUMBER OF UNKNOWN FUNCTIONS
   T : TIME VARIABLE
   X : APPROXIMATE VALUE OF SOLUTION
   (T0,X0) : NITIAL VALUE OF (T,X)
   H : TIME INCREMENT
   TMAX : UPPER LIMIT OF TIME
*/

#include <stdio.h>
#include <stdlib.h>

double func(double t, double x[], double f[], int nfunc);

int main(void)
{
  int nfunc, method, n, i, nstep;
  double t0, h, Tmax, t;
  double x[10], u[10];
  double fk1[10],fk2[10],fk3[10],fk4[10];
  printf("LINEAR SYSTEM        : NFUNC=1\n");
  printf("VAN DER POL EQUATION :      =2\n");
  printf("EXERCISE-2           :      =3\n");
  printf("INPUT : NFUNC=\n");
  scanf("%d", &nfunc);
  printf("EULER       : METHOD=1\n");
  printf("HEUN        :       =2\n");
  printf("RUNGE-KUTTA :       =3\n");
  printf("INPUT : METHOD=\n");
  scanf("%d", &method);
  printf(" 'INPUT : N=\n");
  scanf("%d", &n);
  printf(" 'INPUT : T0=\n");
  scanf("%lf", &t0);
  for (i=0; i<n; i++) {
    printf("INPUT : X0(%3d)=\n", i+1);
    scanf("%lf", &x[i]);
  }
  printf(" 'INPUT : H=\n");
  scanf("%lf", &h);
  printf(" 'INPUT : TMAX=\n");
  scanf("%lf", &Tmax);
  // CALCULATION
  t=t0;
  nstep=0;
  do {
    if (method == 1) {
      func(t,x,fk1,nfunc);
      for (i=0; i<n; i++)
    x[i] += h * fk1[i];
    }
    else if (method == 2) {
      func(t,x,fk1,nfunc);
      for (i=0; i<n; i++)
    u[i] = x[i] + h * fk1[i];
      func(t+h,u,fk2,nfunc);
      for (i=0; i<n; i++)
    x[i] += h * (fk1[i] + fk2[i]) / 2.0;
    }
    else {
      func(t,x,fk1,nfunc);
      for (i=0; i<n; i++)
    u[i] = x[i] + h * fk1[i] / 2.0;
      func(t+h/2.0,u,fk2,nfunc);
      for (i=0; i<n; i++)
    u[i] = x[i] + h * fk2[i] / 2.0;
      func(t+h/2.0,u,fk3,nfunc);
      for (i=0; i<n; i++)
    u[i] = x[i] + h * fk3[i];
      func(t+h,u,fk4,nfunc);
      for (i=0; i<n; i++)
    x[i] += h * (fk1[i] + 2.0 * fk2[i] + 2.0 * fk3[i] + fk4[i]) / 6.0;
    }
    nstep++;
    t = t0 + h * nstep;
    // OUTPUT
    printf("T=%12.4e\n", t);
    for (i = 0; i < 5; i++)
      printf("  I     X(I)    ");
    printf("\n");
    for (i=0; i<n; i++) {
      printf("%3d%12.4e ", i+1, x[i]);
      if ((i+1) % 5 == 0 || (i+1) == n)
    printf("\n");
    }
  }
  while ((h > 0.0 && t+h < Tmax+0.1*h) || (h < 0.0 && t+h > Tmax+0.1*h));
}

double func(double t, double x[], double f[], int nfunc)
{
  if (nfunc == 1) {
    f[0] = -4.0 * x[0] + 2.0 * x[1];
    f[1] = -3.0 * x[0] + x[1];
  }
  else if (nfunc == 2) {
    f[0] = x[1];
    f[1] = (1.0 - x[0] * x[0]) * x[1] - x[0];
  }
  else if (nfunc == 3) {
    f[0] = x[1];
    f[1] = -x[0] - 0.2 * x[1];
    if (x[1] < 0.0) f[1] = f[1] - 1.0;
    if (x[1] > 0.0) f[1] = f[1] + 1.0;
  }
  return 0.0; // ここに来ない
}
